module.exports = {
  root: true,
  extends: [
    'eslint-config-airbnb-base',
    'eslint-config-airbnb-base/rules/strict',
    'eslint-config-standard',
  ],
  plugins: [
    'standard',
    'filenames',
  ],
  parserOptions: {
    ecmaVersion: 2016,
    sourceType: 'module',
  },
  env: {
    browser: true,
    node: true,
    es6: true,
    mocha: true,
    commonjs: true,
    jest: true,
  },
  rules: {
    'arrow-parens': ['error', 'always'],
    'arrow-body-style': ['error', 'as-needed'],
    'comma-dangle': ['error', 'always-multiline'],
    'no-console': 'error',
    'prefer-template': 'error',
    'class-methods-use-this': 0,
    'newline-before-return': 'error',
    'object-curly-newline': [
      'error',
      {
        ObjectExpression: {
          multiline: true,
          consistent: true,
          minProperties: 5,
        },
        ObjectPattern: {
          multiline: true,
          consistent: true,
          minProperties: 5,
        },
      },
    ],
    'no-underscore-dangle': [
      'error',
      {
        allow: [
          '_error',
        ],
      },
    ],
    'id-length': ['error'],
    'max-lines': [
      'error',
      {
        max: 300,
        skipBlankLines: true,
        skipComments: true,
      },
    ],
    'max-len': [
      'error',
      {
        code: 120,
        ignoreComments: true,
        ignoreUrls: true,
        ignoreRegExpLiterals: true,
        ignoreStrings: true,
        ignoreTemplateLiterals: true
      },
    ],
    'no-plusplus': [
      'error',
      {
        allowForLoopAfterthoughts: true,
      },
    ],
    'func-style': [
      'error',
      'declaration',
      {
        'allowArrowFunctions': true,
      },
    ],
    'func-names': ['error', 'as-needed'],
    'no-unused-vars': [
      'error',
      {
        vars: 'all',
        ignoreRestSiblings: true,
        args: 'after-used',
        caughtErrors: 'all',
        caughtErrorsIgnorePattern: '^ignore',
      },
    ],
    'operator-linebreak': [
      'error',
      'after',
      {
        overrides: {
          '?': 'before',
          ':': 'before',
        },
      },
    ],
    'filenames/match-exported': 'error',
  },
}
